#!/usr/bin/perl -w
#
# touch dimmer
#
# table.pl - create a (semi)logarithmic pwm table
#
# (c) Axel (XL) Schwenke, axel.schwenke@gmx.net
#
# $Id: table.pl 345 2016-06-12 16:06:39Z schwenke $

my $start    = 256;  #timer cycle length = 100%
my $stop     = 25;   #minimum PWM length
my $mindelta = 1;    #minimum step
my $factor   = 1.15; #factor between steps

my $step = 0;
my @table = ();

while ($step < 256 && $start >= $stop) {
    push @table, int($start+0.499)-1;
    my $new = $start / $factor;
    if ($start - $new < $mindelta) {
        $start -= $mindelta;
    } else {
        $start = $new;
    }
    $step++;
}

printf  "/* generated pwm table (%d..255); factor=%f */\n\n", $stop, $factor;
printf "#define MAX_LEVEL %d\n", $step-1;
printf "const uint8_t dimm_step[] = {\n\t%d", pop @table;
while ($step = pop @table) {
    printf ", %d", ($step % 65536);
}
print "\n};\n";

